<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_worker;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_worker\MasterWorkerAgree;
use app\common\lists\ListsSearchInterface;


/**
 * MasterWorkerAgree列表
 * Class MasterWorkerAgreeLists
 * @package app\adminapi\listsmaster_worker
 */
class MasterWorkerAgreeLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function setSearch(): array
    {
        return [
            '=' => ['agree_type', 'worker_id', 'sign', 'audit_state', 'pdf_url', 'create_time'],

        ];
    }
    public function queryWhere(){
        $where = [];
        if(isset($this->params['range_update_time']) && !empty($this->params['range_update_time'])){
            $time = [strtotime($this->params['range_update_time'][0]), strtotime($this->params['range_update_time'][1])];
            $where[] = ['update_time', 'between', $time];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function lists(): array
    {
        return MasterWorkerAgree::with(['masterWorkerInfo'])->where($this->searchWhere)->where($this->queryWhere())
            ->field(['id', 'agree_type', 'worker_id', 'sign', 'pdf_url', 'create_time', 'audit_state','update_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/17 15:20
     */
    public function count(): int
    {
        return MasterWorkerAgree::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}